Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005WalkCalibrationMainBehavior Class Reference

`#include <GT2005WalkCalibrationBasicBehaviors.h>`

Inheritance diagram for GT2005WalkCalibrationMainBehavior:

[legend]
Collaboration diagram for GT2005WalkCalibrationMainBehavior:

[legend]
List of all members.

## Public Member Functions
| GT2005WalkCalibrationMainBehavior (BehaviorControlInterfaces &interfaces, Xabsl2ErrorHandler &errorHandler)
void | registerSymbols (Xabsl2Engine &engine)
virtual void | execute ()
| Executes the basic behavior.
## Private Types
enum | ResultCodes { resultUnready = 0, resultReady = 1, resultMeasure = 2, resultReposition = 3, resultInteraction = 4 }
enum | State { stateNotInitialized, stateMeasureStart, stateMeasure, stateMeasureFinished, stateCalibrationFinished }
enum | MeasureStatus { before, measuring, end }
## Private Member Functions
Pose2D | calculateStartPose (const Pose2D &base)
void | Initialize ()
void | Measure ()
void | removeExtreme (bool *pBadIndex, bool removeMaximum)
## Static Private Member Functions
double | minDistanceToBorder (Vector2< double > &t)
## Private Attributes
double | initializeParameter
double | rotationParameter
Pose2D | startPose
double | startPoseAngle
bool | startPoseCalculated
int | startPoseBadCount
double | initializationTime
int | measureCount
char | filename [20]
int | qCount
double | qSum
double | result
double | measureStartTime
double | measureStopTime
double | tempTime
double | startOffset
double | measureDuration
double | stopOffset
Vector2< double > | translationStartPoint
Vector2< double > | translationStopPoint
Vector2< double > | test
double | rotationStartAngle
double | rotationStopAngle
double | rotationTemp
double | measureStartTime0
double | measureStopTime0
Vector2< double > | translationStartPoint0
Vector2< double > | translationStopPoint0
double | rotationStartAngle0
double | rotationStopAngle0
double | walkingDirection
int | currentTable
int | currentPoint
int | currentRotation
int | robotColor
int | robotNumber
OdometryPoint | measurePoints [measureSize]
int | tempPoseCount
Pose2D | tempPose [50]
double | tempTimeStart
double | tempTimeStop
Pose2D | camRobotPose
double | camTimestamp
int | robotNotDetectedCount
Vector2< double > | center
| center of the camera
State | state
MeasureStatus | measureStatus
## Static Private Attributes
const int | measureSize = 195

## Member Enumeration Documentation

enum GT2005WalkCalibrationMainBehavior::ResultCodes`[private]`

  | Enumeration values:
  resultUnready |
  resultReady |
  resultMeasure |
  resultReposition |
  resultInteraction |
Definition at line 30 of file GT2005WalkCalibrationBasicBehaviors.h.

enum GT2005WalkCalibrationMainBehavior::State`[private]`

  | Enumeration values:
  stateNotInitialized |
  stateMeasureStart |
  stateMeasure |
  stateMeasureFinished |
  stateCalibrationFinished |
Definition at line 80 of file GT2005WalkCalibrationBasicBehaviors.h.

enum GT2005WalkCalibrationMainBehavior::MeasureStatus`[private]`

  | Enumeration values:
  before |
  measuring |
  end |
Definition at line 91 of file GT2005WalkCalibrationBasicBehaviors.h.

## Constructor & Destructor Documentation

GT2005WalkCalibrationMainBehavior::GT2005WalkCalibrationMainBehavior | ( | BehaviorControlInterfaces & | interfaces,
|  | Xabsl2ErrorHandler & | errorHandler
| ) |

| Definition at line 11 of file GT2005WalkCalibrationBasicBehaviors.cpp. References initializeParameter, Xabsl2BasicBehavior::registerParameter(), resultUnready, rotationParameter, startPoseCalculated, stateNotInitialized, and tempPoseCount.

Here is the call graph for this function:

## Member Function Documentation

Pose2D GT2005WalkCalibrationMainBehavior::calculateStartPose | ( | const Pose2D & | base | ) | `[private]`

| Definition at line 506 of file GT2005WalkCalibrationBasicBehaviors.cpp. References camRobotPose, min, minDistanceToBorder(), NCIRCLE, NCROSS, pi, Pose2D::rotation, Pose2D::translation, Vector2< double >::x, and Vector2< double >::y. Referenced by execute().

Here is the call graph for this function:

double GT2005WalkCalibrationMainBehavior::minDistanceToBorder | ( | Vector2< double > & | t | ) | `[static, private]`

| Definition at line 491 of file GT2005WalkCalibrationBasicBehaviors.cpp. References min, Vector2< V >::x, and Vector2< V >::y. Referenced by calculateStartPose().

void GT2005WalkCalibrationMainBehavior::Initialize | ( |  | ) | `[private]`

| Definition at line 148 of file GT2005WalkCalibrationBasicBehaviors.cpp. References before, GT2005WalkCalibrationMainBehavior::OdometryPoint::controlled, currentPoint, currentRotation, currentTable, InStream< InFile, InBinary >::eof(), InFile::exists(), SystemCall::getCurrentSystemTime(), getPlayer(), Player::getPlayerNumber(), Player::getTeamColor(), idText, initializationTime, measureCount, GT2005WalkCalibrationMainBehavior::OdometryPoint::measured, measureDuration, measurePoints, measureSize, measureStatus, OUTPUT, pi, resultReady, robotColor, robotNumber, rotationParameter, startOffset, startPoseBadCount, stateMeasureStart, stopOffset, Vector2< double >::x, and Vector2< double >::y. Referenced by execute().

Here is the call graph for this function:

void GT2005WalkCalibrationMainBehavior::Measure | ( |  | ) | `[private]`

| Definition at line 236 of file GT2005WalkCalibrationBasicBehaviors.cpp. References before, camRobotPose, camTimestamp, GT2005WalkCalibrationMainBehavior::OdometryPoint::controlled, currentPoint, SystemCall::getCurrentSystemTime(), idText, initializationTime, measureCount, GT2005WalkCalibrationMainBehavior::OdometryPoint::measured, measureDuration, measurePoints, measureSize, measureStartTime, measureStartTime0, measureStatus, measureStopTime, measureStopTime0, measuring, MotionRequest::motionType, normalize(), OUTPUT, qCount, qSum, removeExtreme(), resultInteraction, resultMeasure, resultReposition, resultUnready, Pose2D::rotation, rotationStartAngle, rotationStartAngle0, rotationStopAngle, rotationStopAngle0, rotationTemp, startOffset, startPoseBadCount, startPoseCalculated, stateCalibrationFinished, stateMeasure, stateMeasureFinished, stateMeasureStart, stateNotInitialized, tempPose, tempPoseCount, tempTime, tempTimeStart, tempTimeStop, Pose2D::translation, translationStartPoint, translationStartPoint0, translationStopPoint, translationStopPoint0, WalkRequest::walkParams, MotionRequest::walkRequest, WalkRequest::walkType, Vector2< V >::x, Vector2< double >::x, Vector2< V >::y, and Vector2< double >::y. Referenced by execute().

Here is the call graph for this function:

void GT2005WalkCalibrationMainBehavior::removeExtreme | ( | bool * | pBadIndex,
|  | bool | removeMaximum
| ) | `[private]`

| Definition at line 25 of file GT2005WalkCalibrationBasicBehaviors.cpp. References tempPose, and tempPoseCount. Referenced by Measure().

void GT2005WalkCalibrationMainBehavior::registerSymbols | ( | Xabsl2Engine & | engine | ) |

| Definition at line 581 of file GT2005WalkCalibrationBasicBehaviors.cpp. References Xabsl2Symbols::registerDecimalInputSymbol(), startPose, startPoseAngle, Pose2D::translation, Vector2< double >::x, and Vector2< double >::y. Referenced by GT2005WalkCalibrationBasicBehaviors::registerBasicBehaviors().

Here is the call graph for this function:

void GT2005WalkCalibrationMainBehavior::execute | ( |  | ) | `[virtual]`

| Executes the basic behavior. Implements Xabsl2BasicBehavior. Definition at line 62 of file GT2005WalkCalibrationBasicBehaviors.cpp. References calculateStartPose(), camRobotPose, camTimestamp, currentPoint, SystemCall::getCurrentSystemTime(), GTCamWorldState::getRobotPose(), GTCamWorldState::getTimestamp(), idText, Initialize(), initializeParameter, Measure(), measurePoints, OUTPUT, resultInteraction, resultReposition, robotColor, robotNotDetectedCount, robotNumber, Pose2D::rotation, startPose, startPoseAngle, startPoseBadCount, startPoseCalculated, stateMeasureStart, tempPose, tempPoseCount, toDegrees(), Pose2D::translation, Vector2< V >::x, Vector2< double >::x, Vector2< V >::y, and Vector2< double >::y.

Here is the call graph for this function:

## Member Data Documentation

double GT2005WalkCalibrationMainBehavior::initializeParameter`[private]`

| Definition at line 15 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and GT2005WalkCalibrationMainBehavior().

double GT2005WalkCalibrationMainBehavior::rotationParameter`[private]`

| Definition at line 16 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by GT2005WalkCalibrationMainBehavior(), and Initialize().

Pose2D GT2005WalkCalibrationMainBehavior::startPose`[private]`

| Definition at line 18 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and registerSymbols().

double GT2005WalkCalibrationMainBehavior::startPoseAngle`[private]`

| Definition at line 19 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and registerSymbols().

bool GT2005WalkCalibrationMainBehavior::startPoseCalculated`[private]`

| Definition at line 20 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), GT2005WalkCalibrationMainBehavior(), and Measure().

int GT2005WalkCalibrationMainBehavior::startPoseBadCount`[private]`

| Definition at line 21 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), Initialize(), and Measure().

double GT2005WalkCalibrationMainBehavior::initializationTime`[private]`

| Definition at line 22 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

int GT2005WalkCalibrationMainBehavior::measureCount`[private]`

| Definition at line 23 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

char GT2005WalkCalibrationMainBehavior::filename[20]`[private]`

| Definition at line 24 of file GT2005WalkCalibrationBasicBehaviors.h.

int GT2005WalkCalibrationMainBehavior::qCount`[private]`

| Definition at line 26 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::qSum`[private]`

| Definition at line 27 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::result`[private]`

| Definition at line 29 of file GT2005WalkCalibrationBasicBehaviors.h.

double GT2005WalkCalibrationMainBehavior::measureStartTime`[private]`

| Definition at line 42 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::measureStopTime`[private]`

| Definition at line 42 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::tempTime`[private]`

| Definition at line 42 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::startOffset`[private]`

| Definition at line 43 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

double GT2005WalkCalibrationMainBehavior::measureDuration`[private]`

| Definition at line 43 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

double GT2005WalkCalibrationMainBehavior::stopOffset`[private]`

| Definition at line 43 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize().

Vector2<double> GT2005WalkCalibrationMainBehavior::translationStartPoint`[private]`

| Definition at line 44 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

Vector2<double> GT2005WalkCalibrationMainBehavior::translationStopPoint`[private]`

| Definition at line 44 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

Vector2<double> GT2005WalkCalibrationMainBehavior::test`[private]`

| Definition at line 44 of file GT2005WalkCalibrationBasicBehaviors.h.

double GT2005WalkCalibrationMainBehavior::rotationStartAngle`[private]`

| Definition at line 45 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::rotationStopAngle`[private]`

| Definition at line 45 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::rotationTemp`[private]`

| Definition at line 45 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::measureStartTime0`[private]`

| Definition at line 47 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::measureStopTime0`[private]`

| Definition at line 47 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

Vector2<double> GT2005WalkCalibrationMainBehavior::translationStartPoint0`[private]`

| Definition at line 48 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

Vector2<double> GT2005WalkCalibrationMainBehavior::translationStopPoint0`[private]`

| Definition at line 48 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::rotationStartAngle0`[private]`

| Definition at line 49 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::rotationStopAngle0`[private]`

| Definition at line 49 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::walkingDirection`[private]`

| Definition at line 51 of file GT2005WalkCalibrationBasicBehaviors.h.

int GT2005WalkCalibrationMainBehavior::currentTable`[private]`

| Definition at line 52 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize().

int GT2005WalkCalibrationMainBehavior::currentPoint`[private]`

| Definition at line 52 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), Initialize(), and Measure().

int GT2005WalkCalibrationMainBehavior::currentRotation`[private]`

| Definition at line 52 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize().

int GT2005WalkCalibrationMainBehavior::robotColor`[private]`

| Definition at line 53 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and Initialize().

int GT2005WalkCalibrationMainBehavior::robotNumber`[private]`

| Definition at line 53 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and Initialize().

const int GT2005WalkCalibrationMainBehavior::measureSize = 195`[static, private]`

| Definition at line 61 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

OdometryPoint GT2005WalkCalibrationMainBehavior::measurePoints[measureSize]`[private]`

| Definition at line 66 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), Initialize(), and Measure().

int GT2005WalkCalibrationMainBehavior::tempPoseCount`[private]`

| Definition at line 67 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), GT2005WalkCalibrationMainBehavior(), Measure(), and removeExtreme().

Pose2D GT2005WalkCalibrationMainBehavior::tempPose[50]`[private]`

| Definition at line 68 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), Measure(), and removeExtreme().

double GT2005WalkCalibrationMainBehavior::tempTimeStart`[private]`

| Definition at line 69 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

double GT2005WalkCalibrationMainBehavior::tempTimeStop`[private]`

| Definition at line 69 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Measure().

Pose2D GT2005WalkCalibrationMainBehavior::camRobotPose`[private]`

| Definition at line 71 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by calculateStartPose(), execute(), and Measure().

double GT2005WalkCalibrationMainBehavior::camTimestamp`[private]`

| Definition at line 72 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute(), and Measure().

int GT2005WalkCalibrationMainBehavior::robotNotDetectedCount`[private]`

| Definition at line 73 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by execute().

Vector2<double> GT2005WalkCalibrationMainBehavior::center`[private]`

| center of the camera Definition at line 77 of file GT2005WalkCalibrationBasicBehaviors.h.

State GT2005WalkCalibrationMainBehavior::state`[private]`

| Definition at line 89 of file GT2005WalkCalibrationBasicBehaviors.h.

MeasureStatus GT2005WalkCalibrationMainBehavior::measureStatus`[private]`

| Definition at line 98 of file GT2005WalkCalibrationBasicBehaviors.h. Referenced by Initialize(), and Measure().

The documentation for this class was generated from the following files:

- Modules/BehaviorControl/GT2005BehaviorControl/GT2005BasicBehaviors/GT2005WalkCalibrationBasicBehaviors.h
- Modules/BehaviorControl/GT2005BehaviorControl/GT2005BasicBehaviors/GT2005WalkCalibrationBasicBehaviors.cpp